/**
 * Generated by Apache Royale Compiler from org/apache/royale/reflection/utils/getInstanceVarsAndAccessors.as
 * org.apache.royale.reflection.utils.getInstanceVarsAndAccessors
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.reflection.utils.getInstanceVarsAndAccessors');

goog.require('org.apache.royale.reflection.AccessorDefinition');
goog.require('org.apache.royale.reflection.TypeDefinition');
goog.require('org.apache.royale.reflection.VariableDefinition');
goog.require('org.apache.royale.reflection.utils.MemberTypes');



/**
 *  A utility method to retrieve all exposed variable and accessor members
 *  It will return variables, and readwrite-only accessors that are public by default, but
 *  you can specific different options to retrieve other combinations.
 *  
 *  @asparam fromDefinition the definition to retrieve the member definitions from
 *  @asparam accessorFilter bitflag combination of MemberTypes.ACCESS_READ_WRITE (the default) or MemberTypes.READ_ONLY or MemberTypes.WRITE_ONLY. Set this to 0 (zero) to exclude all accessors.
 *  @asparam publicOnly true if only public namespaced members should be returned (the default)
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 *
 *  @royaleignorecoercion org.apache.royale.reflection.AccessorDefinition
 *  @royaleignorecoercion org.apache.royale.reflection.VariableDefinition
 * @param {org.apache.royale.reflection.TypeDefinition} fromDefinition
 * @param {number=} accessorFilter
 * @param {boolean=} publicOnly
 * @return {Array}
 */
org.apache.royale.reflection.utils.getInstanceVarsAndAccessors = function(fromDefinition, accessorFilter, publicOnly) {
  accessorFilter = typeof accessorFilter !== 'undefined' ? accessorFilter : 4;
  publicOnly = typeof publicOnly !== 'undefined' ? publicOnly : true;
  var /** @type {Array} */ ret = [];
  if (!fromDefinition)
    return ret;
  ret = ret.concat(fromDefinition.variables);
  var /** @type {Array} */ accessors = accessorFilter ? fromDefinition.accessors : [];
  if (accessors.length && ((accessorFilter & 7) != 7)) {
    var /** @type {number} */ l = (accessors.length) >>> 0;
    while (l--) {
      var /** @type {string} */ access = accessors[l].access;
      var /** @type {boolean} */ includeItem = !!((access == 'readwrite' && (accessorFilter & org.apache.royale.reflection.utils.MemberTypes.ACCESS_READ_WRITE)) || (access == 'readonly' && (accessorFilter & org.apache.royale.reflection.utils.MemberTypes.ACCESS_READ_ONLY)) || (access == 'writeonly' && (accessorFilter & org.apache.royale.reflection.utils.MemberTypes.ACCESS_WRITE_ONLY)));
      if (!includeItem) {
        accessors.splice(l, 1);
      }
    }
  }
  ret = ret.concat(accessors);
  if (publicOnly) {
    l = (ret.length) >>> 0;
    while (l--) {
      var /** @type {Object} */ varDef = ret[l];
      if (varDef.uri)
        ret.splice(l, 1);
    }
  }
  return ret;
}