/**
 * Generated by Apache Royale Compiler from org/apache/royale/reflection/utils/isDerivedType.as
 * org.apache.royale.reflection.utils.isDerivedType
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.reflection.utils.isDerivedType');

goog.require('org.apache.royale.reflection.TypeDefinition');



/**
 *  A utility method to check whether one definition is derived from another
 *
 *  This could be to check whether an interface extends another interface, or a class is a subclass of another class
 *  or whether a class implements an interface.
 *  
 *  @asparam targetType TypeDefinition the definition to verify
 *  @asparam derivedFrom TypeDefinition the definition to verify against
 *  @asreturn true if targetType parameter represents some form of 'descendant' of derivedFrom parameter
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 *
 *  @royaleignorecoercion org.apache.royale.reflection.TypeDefinition
 *  @royalesuppressexport
 * @param {Object} targetType
 * @param {Object} derivedFrom
 * @return {boolean}
 */
org.apache.royale.reflection.utils.isDerivedType = function(targetType, derivedFrom) {
  var /** @type {number} */ i = 0;
  var /** @type {number} */ l = 0;
  if (!targetType || !derivedFrom)
    throw new Error('both arguments must be non-null');
  if (targetType == derivedFrom || targetType.qualifiedName == derivedFrom.qualifiedName)
    return false;
  //var /** @type {number} */ i = 0;
  //var /** @type {number} */ l = 0;
  var /** @type {Array} */ checks;
  if (derivedFrom.kind == 'class') {
    if (targetType.kind == 'interface')
      return false;
    if (derivedFrom.qualifiedName == 'Object')
      return true;
    checks = targetType.baseClasses;
  } else {
    checks = targetType.interfaces;
  }
  l = (checks.length) >> 0;
  var /** @type {string} */ dervivedName = derivedFrom.qualifiedName;
  for (i = 0; i < l; i++) {
    if (derivedFrom == checks[i] || dervivedName == checks[i].qualifiedName)
      return true;
  }
  return false;
}