/**
 * Generated by Apache Royale Compiler from org/apache/royale/reflection/utils/isSameType.as
 * org.apache.royale.reflection.utils.isSameType
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.reflection.utils.isSameType');

goog.require('org.apache.royale.reflection.TypeDefinition');



/**
 *  A utility method to check whether one definition represents the same type (Class or Interface) as another
 *
 *  This check is useful in situations where TypeDefinition.useCache is false
 *  
 *  @asparam type1 TypeDefinition the first definition
 *  @asparam type2 TypeDefinition the second definition
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 *
 *  @royaleignorecoercion org.apache.royale.reflection.TypeDefinition
 *  @royalesuppressexport
 * @param {Object} type1
 * @param {Object} type2
 * @return {boolean}
 */
org.apache.royale.reflection.utils.isSameType = function(type1, type2) {
  if (!type1 || !type2)
    throw new Error('both arguments must be non-null');
  return (type1 == type2 || type1.qualifiedName == type2.qualifiedName);
}